//
//
//  DE431 File Divide Program to File1(-13000 to +10000 ) & File2(+10000 to 17000)
//
//                                                2015/03/21 1st version
//
//                                                S.Takesako
//                                                takesako@mrj.biglobe.ne.jp

// File1: lnxm3000p10000.431
// *** Dates in the Header ***
// -3027215.50  -13001/12/ 9  0.00
// 5373872.50   10001/ 1/23  0.00 (Data Block + 32 days)

// File2: lnxp10001p17000.431
//*** Dates in the Header ***
//5373872.50   10001/ 1/23  0.00
//7930192.50   17000/ 1/11  0.00 (Data Block + 32 days)


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <conio.h>

//  Year/Month/Day/Hour to Julian Date

double JD(double year,double month,double day,double hour,int LST,double longitude)
{
	double s,juday,a,flag;

	flag =1;
	if (longitude <0){ 
		longitude = -longitude;
		flag=-1;
		}

	if ( month < 3 ){
		year = year -1;
		month = month +12;
		};
	s = floor( 365.25 * year) + floor( 30.59 * (month-2.0));
	if (LST==1)
	{juday = s + day + hour/24.0 -  flag*floor(longitude /15.0+0.5)/24.0	+ 1721086.5;}
		else
		{juday = s + day + hour/24.0 -  flag*longitude /15.0/24.0	+ 1721086.5;}


	if ( juday > 2299161 ) {
		a = floor ( year / 400 ) - floor( year / 100)+2;
		juday = juday + a;
		};

	return(juday);

}

//  Julian Date to Year/Month/Day/Hour


void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude)
{
	double flag,Z,Alfa,A,B,C,D,E,F,Day0;
	
	flag = 1;

	if (longitude<0 ){
		longitude = - longitude;
		flag=-1.0;
	}
	
	if (LST==1) juday =  juday +  flag*(double)(int)(longitude /15.0+0.5)/24.0;
		else    juday =  juday +  flag*longitude /15.0/24.0	;
		
	juday = juday + 0.5;
	Z = floor(juday);
	F = juday - Z;

	if (Z < 2299161.0) A = Z;
		else { 
			Alfa = (double)(int) ((Z - 1867216.25)/36524.25);
			A = Z + 1 + Alfa - (double)(int) (Alfa/4.0);}

	B = A + 1524;
	C = floor ((B-122.1)/365.25);
	D = floor (365.25 * C);
	E = (double)(int) ((B-D)/30.6001);

	Day0 = B - D - floor(30.60001*E) + F;
	*day = (double)(int)(Day0);
	*hour= F*24.0;
	if(E<14.0) *month = E-1.0;
	if(E==14.0 || E==15.0)	 *month = E- 13.0;
	if(*month>2.0) *year=C-4716;
	if(*month==1.0 || *month==2.0) *year = C - 4715;

}


// Program to write Header (2blocks) and blocks between jd1 and jd2 
void main(void)
{
	FILE *fp0,*fp1,*fp2;

	float a[663],c[1367];
	double data[2036/2],b[3];
	double jd1,jd2,jd10,jd20;
	long i,size,j;
	double juday,year,month,day,hour,longitude=0.0;
	int LST=0;

	fpos_t	fsize=0;

// Please change directry based on your PC
	fp0 = fopen("e:\\data\\lnxm13000p17000.431","rb") ;
	fp1 = fopen("e:\\data\\lnxm13000p10000.431","wb");   
	fp2 = fopen("e:\\data\\lnxp10000p17000.431","wb");   


	printf("\n*** Start File Creation ***\n\n");

// Read first block of header
	fread (a,sizeof(a),1,fp0);
	fread (b,sizeof(b),1,fp0);
	fread (c,sizeof(c),1,fp0);
//	printf("%10.2f %10.2f %10.2f\n",b[0],b[1],b[2]);


// Revise Start and end date of file 
	b[0]=-3027215.5;// -13001/12/ 9  0.00 Start date of file
	b[1]= 5373872.5;//  10001/ 1/23  0.00 End date of file
	b[2]=b[2];// Day interval(32day for DE431)

	fwrite(a,sizeof(a),1,fp1);
	fwrite(b,sizeof(b),1,fp1);
	fwrite(c,sizeof(c),1,fp1);

	// Revise Start and end date of file 
	b[0]=5373392.5;//  9999/10/ 1  0.00 Start date of file
	b[1]=7930192.5;// 16999/12/10  0.00 End date of file
	b[2]=b[2];// Day interval(32day for DE431)

	fwrite(a,sizeof(a),1,fp2);
	fwrite(b,sizeof(b),1,fp2);
	fwrite(c,sizeof(c),1,fp2);

	fread (data,sizeof(data),1,fp0);
	fwrite(data,sizeof(data),1,fp1);
	fwrite(data,sizeof(data),1,fp2);

	for(i=3;i<=342421;i++){
		if(i%10000==0)printf(" %4.0f/100 \n",(double)i/342421.0*100.0);
		fread (data,sizeof(data),1,fp0);
		if(i<=262536)fwrite(data,sizeof(data),1,fp1);
		if(i>=262522) fwrite(data,sizeof(data),1,fp2);
	}

	printf("\n*** End of File Creation ***\n\n");

	fclose(fp0);
	fclose(fp1);
	fclose(fp2);

//************** Confirmation *******************

	for(j=1;j<=2;j++){

	if(j==1)fp1 = fopen("e:\\data\\lnxm13000p10000.431","rb");   
	if(j==2)fp2 = fopen("e:\\data\\lnxp10000p17000.431","rb");   

// Read first block of header
	fread (a,sizeof(a),1,fp1);
	fread (b,sizeof(b),1,fp1);
	fread (c,sizeof(c),1,fp1);
	printf("*** Dates in the Header ***\n");
	Calendar( b[0],  &year, &month, &day, &hour,LST, longitude)	;
	printf("%10.2f %7.0f/%2.0f/%2.0f %5.2f \n", b[0],year,month,day,hour);
	Calendar( b[1],  &year, &month, &day, &hour,LST, longitude)	;
	printf("%10.2f %7.0f/%2.0f/%2.0f %5.2f (Data Block + %2.0f days)\n\n", b[1],year,month,day,hour,b[2]);

// data at 3rd block(first data block)
	fseek(fp1,sizeof(data)*2,0);
	fread (data,sizeof(data),1,fp1);

	printf("*** Dates in the Data Block ***\n");
	juday=data[0];
	Calendar( juday,  &year, &month, &day, &hour,LST, longitude)	;
	printf("%10.2f %7.0f/%2.0f/%2.0f %5.2f \n", data[0],year,month,day,hour);

// data at last block 
	fseek(fp1,0,SEEK_END); 
	fgetpos(fp1,&fsize);
//	printf("file size %d byte\n",fsize);
	size=(long)fsize/(2036/2)/8;// number of blocks
	fseek(fp1,sizeof(data)*(size-1),0);
	fread (data,sizeof(data),1,fp1);

	juday=data[0];
	Calendar( juday,  &year, &month, &day, &hour,LST, longitude)	;
	printf("%10.2f %7.0f/%2.0f/%2.0f %5.2f\n", data[0],year,month,day,hour);
	fclose(fp1);

	printf("\n*** End of File Confirmation ***\n\n");

//************** Confirmation *******************
	}

}

